// For browser testing, where UnimotionPlugin doesn't exist
if (typeof widget == 'undefined') {

	var UnimotionPlugin = function() {
		function randomNum() {
			var num = Math.random() / 100;
			if (Math.random() > 0.5) {
				num = num * -1;
			}
			return num;
		}

		return {
			'refreshData' : function() {},
			'readX' : randomNum,
			'readY' : randomNum,
			'readZ' : randomNum,
			'detectSms' : function() {
				return true;
			}
		}

	}();
}

function getSmsVal() {
		UnimotionPlugin.refreshData();
		return [UnimotionPlugin.readX(),
				UnimotionPlugin.readY(),
				UnimotionPlugin.readZ()];
	
}

function doLegend(){
	if (window.Processing.data.legend){
		$("#legend").fadeIn();
		if 	(window.Processing.data.vals){
			$("#legend_chars").hide();
			$("#legend_vals").fadeIn();
		}else{
			$("#legend_vals").hide();
			$("#legend_chars").fadeIn();
		}
	}else{
		$("#legend").hide();
		$("#legend_chars").hide();
		$("#legend_vals").hide();
	}
}

function doLabels(){
	hideAllLabels();
	if (window.Processing.data.labels){
		var l = window.Processing.data.line_style;
		var f = window.Processing.data.flips;
		$("#x_label_"+l+"_" + ((f[0])?1:0)).fadeIn();
		$("#y_label_"+l+"_" + ((f[1])?1:0)).fadeIn();
		$("#z_label_"+l+"_" + ((f[2])?1:0)).fadeIn();
		$("#labels").fadeIn();

	}else{
		$("#labels").hide();
	}
	
	if (window.Processing.data.show_fps)
		$("#framerate").show();
	else
		$("#framerate").hide();
		
}

function hideAllLabels(){
	//alert("hiding all labels");
	for (var i=0; i < 3; i++){  
		for (var j=0; j < 2; j++){
			$("#x_label_"+i+"_"+j).hide();
			$("#y_label_"+i+"_"+j).hide();
			$("#z_label_"+i+"_"+j).hide();
		}
	}
}

function savePrefs(){
	if(window.widget){
	
	    widget.setPreferenceForKey(window.Processing.data.line_style, "line_style");
	    widget.setPreferenceForKey(window.Processing.data.colors, "colors");
	    widget.setPreferenceForKey(window.Processing.data.labels, "labels");
	    widget.setPreferenceForKey(window.Processing.data.legend, "legend");
	    widget.setPreferenceForKey(window.Processing.data.show_fps, "show_fps");
		widget.setPreferenceForKey(window.Processing.data.vals, "vals");
	    widget.setPreferenceForKey(window.Processing.data.pause_hidden, "pause_hidden");
	    widget.setPreferenceForKey(window.Processing.data.fps, "fps");
	    widget.setPreferenceForKey(window.Processing.data.rel_size, "rel_size");
	    widget.setPreferenceForKey(window.Processing.data.delta_z, "delta_z");

	    widget.setPreferenceForKey(window.Processing.data.flips[0], "flips_0");
	    widget.setPreferenceForKey(window.Processing.data.flips[1], "flips_1");
	    widget.setPreferenceForKey(window.Processing.data.flips[2], "flips_2");
	
	}
}

function getPrefs(){
	var defaults = [2,true,false,false,false,true,[false,false,false],0.4,1,true,1.0];
	
	
	if(window.widget){
	
		var line = widget.preferenceForKey("line_style");
	    if (line != undefined)
			window.Processing.data.line_style 	= parseInt(line);
		
		var delta = widget.preferenceForKey("delta_z");
	    if (delta != undefined)
			window.Processing.data.delta_z 	= parseFloat(delta);
			
		window.Processing.data.colors 		= widget.preferenceForKey("colors");
	    window.Processing.data.labels 		= widget.preferenceForKey("labels");
	    window.Processing.data.legend 		= widget.preferenceForKey("legend");
	    window.Processing.data.show_fps 	= widget.preferenceForKey("show_fps");
	    window.Processing.data.vals 		= widget.preferenceForKey("vals");
	    window.Processing.data.pause_hidden	= widget.preferenceForKey("pause_hidden");
	    window.Processing.data.fps			= widget.preferenceForKey("fps");
	    window.Processing.data.rel_size		= widget.preferenceForKey("rel_size");
		window.Processing.data.flips 		= new Array(3);
		window.Processing.data.flips[0]		= widget.preferenceForKey("flips_0");
		window.Processing.data.flips[1]	 	= widget.preferenceForKey("flips_1");
		window.Processing.data.flips[2]		= widget.preferenceForKey("flips_2");
		if (window.Processing.data.flips[0] == undefined)
			window.Processing.data.flips = defaults[6];
														
	}

    if (window.Processing.data.line_style == undefined)
		window.Processing.data.line_style = defaults[0];
    if (window.Processing.data.colors == undefined)
		window.Processing.data.colors = defaults[1];
    if (window.Processing.data.labels == undefined)
		window.Processing.data.labels = defaults[2];
    if (window.Processing.data.legend == undefined)
		window.Processing.data.legend = defaults[3];
    if (window.Processing.data.vals == undefined)
		window.Processing.data.vals = defaults[4];
    if (window.Processing.data.pause_hidden == undefined)
		window.Processing.data.pause_hidden = defaults[5];
    if (window.Processing.data.flips == undefined)
		window.Processing.data.flips = defaults[6];
    if (window.Processing.data.fps == undefined)
		window.Processing.data.fps = defaults[7];
    if (window.Processing.data.rel_size == undefined)
		window.Processing.data.rel_size = defaults[8];
    if (window.Processing.data.show_fps == undefined)
		window.Processing.data.show_fps = defaults[9];
    if (window.Processing.data.delta_z == undefined)
		window.Processing.data.delta_z = defaults[10];

	
}



